import State from './State';
import { Patcher, Selector, SetState, StateInitializer, UpdateState } from './types';
export default function useState<T>(state: State<T> | StateInitializer<T> | T, config?: {}): [
    state: T,
    setState: SetState<T>,
    updateState: UpdateState<T>,
    stateObject: State<T>
];
export default function useState<ST, T = unknown>(state: State<T | never> | StateInitializer<T> | T, config: {
    selector: Selector<ST>;
}): [
    state: ST,
    setState: SetState<T>,
    updateState: UpdateState<T>,
    stateObject: State<T>
];
export default function useState<ST, T = unknown>(state: State<T | never> | StateInitializer<T> | T, config: {
    selector: Selector<ST>;
    patcher: Patcher<ST>;
}): [
    state: ST,
    setState: SetState<ST>,
    updateState: UpdateState<ST>,
    stateObject: State<T>
];
